/* pckeys.h */

#ifndef _KEYS_
#define _KEYS_

#define NO_KEY       0x0000

#define ENTER        0x1c0d
#define BS           0x0e08
#define SPACE        0x0020
#define ESC          0x011b
#define TAB          0x0f09
#define SHIFT_TAB    0x0f00

#define ENTER_ASCII  (ENTER & 0xff)
#define BS_ASCII     (BS & 0xff)
#define SPACE_ASCII  (SPACE & 0xff)

#define HOME         0x4700
#define END          0x4f00
#define UP_ARROW     0x4800
#define DOWN_ARROW   0x5000
#define LEFT_ARROW   0x4b00
#define RIGHT_ARROW  0x4d00
#define PAGE_UP      0x4900
#define PAGE_DOWN    0x5100
#define INSERT       0x5200
#define DELETE       0x5300

#define F1  0x3b00
#define F2  0x3c00
#define F3  0x3d00
#define F4  0x3e00
#define F5  0x3f00
#define F6  0x4000
#define F7  0x4100
#define F8  0x4200
#define F9  0x4300
#define F10 0x4400

#define ALT_F1  0x6800
#define ALT_F2  0x6900
#define ALT_F3  0x6a00
#define ALT_F4  0x6b00
#define ALT_F5  0x6c00
#define ALT_F6  0x6d00
#define ALT_F7  0x6e00
#define ALT_F8  0x6f00
#define ALT_F9  0x7000
#define ALT_F10 0x7100

#define SHIFT_F1  0x5400
#define SHIFT_F2  0x5500
#define SHIFT_F3  0x5600
#define SHIFT_F4  0x5700
#define SHIFT_F5  0x5800
#define SHIFT_F6  0x5900
#define SHIFT_F7  0x5a00
#define SHIFT_F8  0x5b00
#define SHIFT_F9  0x5c00
#define SHIFT_F10 0x5d00

#define CTRL_F1  0x5e00
#define CTRL_F2  0x5f00
#define CTRL_F3  0x6000
#define CTRL_F4  0x6100
#define CTRL_F5  0x6200
#define CTRL_F6  0x6300
#define CTRL_F7  0x6400
#define CTRL_F8  0x6500
#define CTRL_F9  0x6600
#define CTRL_F10 0x6700

#endif
