/* TEXT2C.C
 *
 * Reads a text file and generates the C code to display and edit it
 * BG 11/21/93
 * Compile: tcc text2c.c
 */

#include <stdio.h>
#include <string.h>

#include "keywork.h"

char buffer[256];

void main (void)
{
        int x,y;                       /* Screen coordinates */               
        int start,end;                 /* Screen coordinates of prompt text */
        int count;                     /* Number of fields */                 
        int len;                       /* Length of entry space */            
        char space_type;               /* Type of entry space */              
        FILE *display,*declare,*edit;  /* Code files */

        /* Open files */
        display = fopen ("display.x","wt");     
        declare = fopen ("declare.x","wt");
        edit = fopen ("edit.x","wt");

        fprintf (edit,"\tswitch (field)\n\t{\n");
        fprintf (display,"\tclrscr ();\n");

        /* Initialize vertical screen position */
        y = 0;

        /* Initialize field count */
        count = 0;

        /* While not end of file */
        while (gets(&buffer[0]))
        {
                /* Set horizontal screen position */
                x = 0;

                y++;

                /* While not end of line */
                while (buffer[x] != '\0')
                {
                        /* Set prompt text starting position */
                        start = x + 1;

                        /* While more prompt text */
                        while ((strchr(ENTRY_SPACE,buffer[x]) == NULL) && (buffer[x] != '\0'))
                                 x++;

                        /* Set prompt text end position */
                        end = x;

                        /* Get entry space type */
                        space_type = buffer[x];

                        /* While more entry space */
                        while ((buffer[x] == space_type) && (buffer[x] != '\0'))
                                x++;

                        /* Calculate length of entry space */
                        len = x - end;

                        /* Write code to position and display prompt */
                        fprintf (display,"\tgotoxy (%i,%i);\n\tprintf (\"%.*s\");\n",
                           start,y,end-start+1,&buffer[start-1]);

                        /* If there is entry space after the prompt */
                        if (buffer[end] != '\0')
                        {
                                /* Declare a variable for the entry */
                                fprintf (declare,"char buffer%i[%i] = \"\\0\", *field%i = &buffer%i[0];\n",count,len+1,count,count);

                                /* Write code to position and accept the entry */
                                fprintf (edit,"\tcase %i:\n",count);

                                /* Read entry */
                                fprintf (edit,"\t\tkey = get_string (%i,%i,field%i,%i,'%c');\n",end+1,y,count,len,space_type); 

                                fprintf (edit,"\t\tbreak;\n");
                                count++;
                        }
                }

        }

        /* Close switch statement */
        fprintf (edit,"\t}");

        /* Set field count */
        fprintf (edit,"\tfield_count = %i;\n",count);

        /* Close all files */
        fcloseall ();
}

